#ifndef _CALCSLICES_H_
#define _CALCSLICES_H_

#include <unistd.h>

/* Número máximo de aplicações (processos pai no CPUReserve) */
#define MAX_APPS 32

typedef struct sliceList {
    short int nCPUs;            /* Number of available CPUs */
    char limitPerCPU;           /* 0 a 100 (%) */
    unsigned long period;
    int nApps;                  /* Number of applications stored */
    int pid[MAX_APPS];
    short int nTasks[MAX_APPS]; /* Number of threads/procs each app has */
    unsigned long slice[MAX_APPS];

} *sliceListT;

void addAppToSliceList(sliceListT list, int pid, unsigned char nTasks);
void calcSlices(sliceListT list);
sliceListT createSliceList(short int nCPUs, char limitPerCPU, unsigned long period);
void freeSliceList(sliceListT list);
unsigned long getSliceFromSliceList(sliceListT list, int pid);
void removeAppFromSliceList(sliceListT list, int pid);
void setSliceListNTasks(sliceListT list, int pid, unsigned char nTasks);
void setSliceListParams(sliceListT list, short int nCPUs, char limitPerCPU);

/* "private" */
void sortSliceListByTasks();

#endif
