#include"client.h"
#include <signal.h>

pid_t pid = -1;
int sockfd = -1;
char hostName[32];
int portNumber;
int fdOut, fdErr;

void error(char *msg)
{
    perror(msg);
    exit(1);
}

/* Solicita ao servidor o fim do processo que estava monitorando as saídas */
void killClientProcess()
{
    char buf[32];

    sockfd = createCliSocket(hostName, portNumber);
    buf[0] = '\0';
    strcat(buf, KILL_PID);
    sendClientOption(sockfd, buf);
    sendKillMsg(sockfd, pid);
    readFIFOs(fdOut, fdErr);
    exit(0);
}

int main(int argc, char **argv, char **env)
{
    char *command;
    int numParams;
    int i;
    char params[512];
    char *tempBuffer = NULL;
    char *token;
    char serverMsg[256];

    signal(SIGINT, killClientProcess);

    if (argc < 3) {
        fprintf(stderr, "usage %s machine:port command <args,...>\n", argv[0]);
        exit(0);
    }

    token = strtok_r(argv[1], ":", &tempBuffer);
    if (token == NULL)
        error
            ("O endereço do servidor deve ser da forma machine_name:port. Por exemplo, localhost:8000. Aborting...\n");

    strcpy(hostName, token);
    token = strtok_r(NULL, ":", &tempBuffer);
    if (token == NULL)
        error
            ("O endereço do servidor deve ser da forma machine_name:port. Por exemplo, localhost:8000. Aborting...\n");

    portNumber = atoi(token);

    sockfd = createCliSocket(hostName, portNumber);
    if (sockfd == -1)
        error("ERRO ao criar socket.\n");

    command = strdup(argv[2]);
    numParams = argc - 3;
    params[0] = '\0';
    for (i = 0; i < numParams; i++) {
        strcat(params, argv[3 + i]);
        if (i < (numParams - 1))
            strcat(params, " ");
    }

    /* Envia o nome do executável e parâmetros do
       processo a ser executado para o servidor */
    serverMsg[0] = '\0';
    strcat(serverMsg, RESERVE);
    sendClientOption(sockfd, serverMsg);
    pid = sendReserveMsg(sockfd, command, params);

    getFIFOs(&fdOut, &fdErr, pid);
    readFIFOs(fdOut, fdErr);

    return 0;
}
