#include "test.h"
#include <stdio.h>

#define bool int
#define true 1
#define false 0

#define RED  31
#define BLUE 34

int __sucesses = 0;
int __failures = 0;

void __color_print(int color, char *msg)
{
    printf("%c[%d;%dm%s%c[%dm\n", 27, 1, color, msg, 27, 0);
}

void __print_failure(char *msg, char *file, int line)
{
    char cmsg[256];

    sprintf(cmsg, "FAILURE: %s on %s:%d", msg, file, line);
    __color_print(RED, cmsg);
    __failures++;
}

void __print_success(char *msg)
{
    char cmsg[256];

    sprintf(cmsg, "SUCCESS: %s", msg);
    __color_print(BLUE, cmsg);
    __sucesses++;
}

int __assert_true(bool res, char *msg, char *file, int line)
{

    if (res) {
        __print_success(msg);
        return true;
    } else
        __print_failure(msg, file, line);
    return false;
}

void __assert_equals(int expected, int res, char *msg, char *file, int line)
{
    char dbgMsg[128];

    if (!__assert_true(expected == res, msg, file, line)) {
        sprintf(dbgMsg, "         Expected %d, but got %d.", expected, res);
        __color_print(RED, dbgMsg);
    }
}

void __print_summary()
{
    char msg[128];

    printf("%d assertions\n", __sucesses + __failures);
    sprintf(msg, "SUCCESSES: %d", __sucesses);
    __color_print(BLUE, msg);
    sprintf(msg, "FAILURES:  %d", __failures);
    __color_print(RED, msg);
}
