////////////////////////////////////////////////////////////////////////////////////////////
// Project: NCC InteGrade Interface                           //
// Developed by: Giulian Dalton Luz & Rogerio Guaraci dos Santos              //
// Date: 8/12/2003                                    //
// Version: Beta 1                                    //
// Module Description: Socket.h. Definitions of the Socket class.                 //
////////////////////////////////////////////////////////////////////////////////////////////

#ifndef Socket_class
#define Socket_class

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <unistd.h>
#include <string>
#include <arpa/inet.h>

const int MAXHOSTNAME = 200;
const int MAXCONNECTIONS = 5;
const int MAXRECV = 500;

class Socket
{
	public:
		// Server initialization
		Socket();
		bool create();
		bool bind ( const int port );
		bool listen() const;
		bool accept ();

		// Client initialization
		bool connect ( const std::string host, const int port );

		// Data Transimission
		bool send ( const std::string ) const;
		int recv ( std::string& ) const;

		void set_non_blocking ( const bool );

		bool is_valid() const { return listenFd != -1; }
		void close();
		void closeListening();
		void closeConnection();

	private:
		int listenFd;
		int connFd;
		sockaddr_in m_addr;

};
#endif
